#include <stdio.h>
#include <stdlib.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/proxy.h>
#include <string.h>
#include <math.h>
#include <i86.h>
#include <unistd.h>

#include "globmsg.h"
#include "nortlib.h"
#include "ttdriver.h"

#include "regnames.h"
#include "panthermsg.h"
#include "stop.h"
#include "elec.h"
#include "valves.h"
#include "msd.h"
#include "omega.h"
#include "maycomm.h"
#include "reveal.h"


void shutdownservers() {
	pid_t 	rs_pid;
 	char 	Smsg[5],
			Rmsg[10];

	// shutdown MSD
	rs_pid = qnx_name_locate (0, NAME_MSD, 0, NULL);
	if (rs_pid != -1) {
		Smsg[0] = msg_msdQuit;
		Send(rs_pid, Smsg, Rmsg, sizeof(Smsg), sizeof(Rmsg));
	}

	// shutdown Omegas
	rs_pid = qnx_name_locate (0, NAME_TEMPS, 0, NULL);
	if (rs_pid != -1) {
		Smsg[0] = msgI_Quit;
		Send(rs_pid, Smsg, Rmsg, sizeof(Smsg), sizeof(Rmsg));
	}

	// shutdown smart electrometers
	rs_pid = qnx_name_locate (0, NAME_SMART, 0, NULL);
	if (rs_pid != -1) {
		Smsg[0] = msg_smartQuit;
		Send(rs_pid, Smsg, Rmsg, sizeof(Smsg), sizeof(Rmsg));
	}

	// shutdown valve server
	rs_pid = qnx_name_locate (0, NAME_VALVE, 0, NULL);
	if (rs_pid != -1) {
		Smsg[0] = msg_valveQuit;
		Send(rs_pid, Smsg, Rmsg, sizeof(Smsg), sizeof(Rmsg));
	}

	// shutdown Maycomm TDL serial driver
	rs_pid = qnx_name_locate (0, NAME_MAYCOMM, 0, NULL);
	if (rs_pid != -1) {
		Smsg[0] = msg_TDLquit;
		Send(rs_pid, Smsg, Rmsg, sizeof(Smsg), sizeof(Rmsg));
	}

	// shutdown REVEAL ethernet driver
	rs_pid = qnx_name_locate (0, NAME_REVEAL, 0, NULL);
	if (rs_pid != -1) {
		Smsg[0] = msg_RVLquit;
		Send(rs_pid, Smsg, Rmsg, sizeof(Smsg), sizeof(Rmsg));
	}


}

void SafeState( ) {

		/* stop the msd */
		sendMSDmessage( msg_msdStopRun );
	
		/* move the valves */
		switch_ssv( 1, 1 ); delay(200);
		switch_ssv( 2, 1 ); delay(200);
		switch_gsv( 3, 1 ); delay(200);
		switch_gsv( 4, 1 ); delay(200);
		switch_gsv( 5, 1 ); delay(200);
		switch_gsv( 6, 1 ); 

		/* Peltiers off */
		tt_scdc_command( 16 );
		tt_scdc_command( 17 );

		/* PAN source off */
		tt_scdc_command( 18 );		// lamp
		tt_scdc_command( 19 );		// flow controller
		
		/* other PAN sols */
		tt_scdc_command( 4 );		// air
		tt_scdc_command( 5 );		// samp in
		tt_scdc_command( 6 );		// PAN gas
		tt_scdc_command( 107 );		// samp out

		/* Trap relays off*/
		tt_scdc_command( 20 );
		tt_scdc_command( 21 );
		tt_scdc_command( 22 );
		tt_scdc_command( 23 );

		/* Samp solenoids off */
		tt_scdc_command( 0 );
		tt_scdc_command( 2 );
		tt_scdc_command( 103 );
	
		/* PAN O2 flush off */
		tt_scdc_command( 1 );


		delay(1000);

		shutdownservers();
		delay(500);

}

